

% gaussian_sinc_3.m - Gauusian windowed sinc waveform
% written by Nadav Levanon on 24 January 2010
% Differs from "gaussian_sinc.m" by plotting the phase too

% single bit shape
nn=201;  nn2=(nn-1)/2; nn22=nn2/2;
small=.00000001;
nnn=-nn2:nn2;
arg_bit=small+4*pi/nn*nnn;
amp_bit=sin(arg_bit)./arg_bit;
 
s_gauss=.7; 
gauss_weight=exp(-0.5*(nnn./(nn/4*s_gauss)).^2);
ab_a=amp_bit.*gauss_weight;

sig_type=input(' Barker13 =1, P4 =2, single bit =3,  = ? ');

if sig_type==1
    phase_vec=pi*[0 0 0 0 0 1 1 0 0 1 0 1 0];  % Barker 13
elseif sig_type==2
    mm=input(' No. of elements of P4 signal = ? ');
    m=1:mm;
    phase_vec=pi*(1/mm*(m-1).^2-(m-1)); % P4
elseif sig_type==3
    phase_vec=[0 0 0 0 0 0 0 0 0 0];
end

lb=length(phase_vec);
vec_length=(lb+3)*nn22+1;
ab=zeros(lb,vec_length);
bpv=ones(1,nn); % bit phase vector

for k=1:lb
  ab(k,:)=[zeros(1,(k-1)*nn22), ab_a.*exp(j*phase_vec(k)*bpv) , zeros(1,(lb-k)*nn22)];
end

u_amp_complex=sum(ab);

u_amp1=abs(u_amp_complex);
u_phase1=1/pi*angle(u_amp_complex);
t_axis=nnn/nn22;
t_axis_10=[0:(length(u_amp1)-1)]/nn22;

figure(10)
subplot(2,1,1)
plot(t_axis_10, u_amp1,'k','linewidth',1.5)
grid on
ylabel(' Amplitude')
axis([-inf inf -0.2 1.2 ])

subplot(2,1,2)
plot(t_axis_10, u_phase1,'k','linewidth',1.5)
grid on
ylabel(' Phase/pi')
axis([-inf inf -1.2 1.2])


figure(11), clf, hold off
plot( t_axis,ab_a,'k','linewidth',2.5)
hold on
plot(t_axis,gauss_weight,'k--','linewidth',1.5)
plot(t_axis,amp_bit,'k:','linewidth',1.5)
grid
axis([ -inf inf -.3 1.1])
xlabel('{\it\tau} / {\itt_b}')

 