

% quadriphase_barker13.m - Barker 13 code using Taylor's quadriphase modification
% written by Nadav Levanon on 2 May 2003
 
nn=14;

mm=100;
mmm=1:mm;
amp_rise=sin(2*pi/4/mm*mmm);
amp_fall=fliplr(amp_rise);
a1 =ones(1,mm);
b1 =-a1;
c1=zeros(1,mm);

% barker13  0 0 0 0 0 1 1 0 0 1 0 1 0 

f_basic1=0.25/mm*[c1 a1 a1 a1 a1 b1 a1 b1 a1 b1 b1 b1 b1 c1];
u_amp1=[amp_rise a1 a1 a1 a1 a1 a1 a1 a1 a1 a1 a1 a1 amp_fall];

figure(10)
plot( u_amp1,'+')
grid
axis([0 mm*nn -.1 1.1])

disp(' ')
disp('  In ambfn7 ')
disp('    use    "u_amp = u_amp1;"     and    "f_basic = f_basic1;" ')
disp(' ')

 